-- CONSTANTS *************************************************************************************

Mission = {}
Mission.radioMenusAdded = {}

Mission.AlfaZoneStatus = "Empty"
Mission.BetaZoneStatus = "Empty"
Mission.GammaZoneStatus = "Empty"

Mission.mapMarkRedBarracks = 0
Mission.mapMarkBlueCommandPost = 0

Mission.blueAlfaSmoke = false
Mission.blueBetaSmoke = false
Mission.blueGammaSmoke = false

Mission.blueAfacRunning = false

Mission.CSARcounter = 0
Mission.CSARbadGuys = {}

Mission.cvn71UnitName = "CVN-71"

Mission.isAlfaBridgeDestroyed = false
Mission.isBetaBridgeDestroyed = false
Mission.isGammaBridgeDestroyed = false

_SETTINGS:SetEraCold()
_SETTINGS:SetA2A_BULLS()
_SETTINGS:SetImperial()

-- HQ CENTERS ***

blueHQ = GROUP:FindByName("BLUE HQ", "Blue HQ")
blueCC = COMMANDCENTER:New(blueHQ, "Blue CC")
blueCC:SetReferenceZones("ALFA")
blueCC:SetReferenceZones("BETA")
blueCC:SetReferenceZones("GAMMA")

redHQ = GROUP:FindByName("RED HQ", "Red HQ")
redCC = COMMANDCENTER:New(redHQ, "Red CC")

-- AWACS / TANKER / RESCUEHELO ***
blueTanker = RECOVERYTANKER:New(UNIT:FindByName(Mission.cvn71UnitName), "BLUE TANKER")
blueTanker:SetTACAN(69, "TKR", "Y")
blueTanker:SetRadio(269)
blueTanker:SetCallsign(CALLSIGN.Tanker.Shell)
blueTanker:SetAltitude(15000)
blueTanker:SetTakeoffHot()
blueTanker:Start()

blueAwacs = RECOVERYTANKER:New(UNIT:FindByName(Mission.cvn71UnitName), "BLUE AWACS")
blueAwacs:SetAWACS()
blueAwacs:SetRadio(265)
blueAwacs:SetCallsign(CALLSIGN.AWACS.Focus, 1)
blueAwacs:SetAltitude(20000)
blueAwacs:SetTakeoffHot()
blueAwacs:Start()

blueRescueHelo = RESCUEHELO:New(UNIT:FindByName(Mission.cvn71UnitName), "BLUE RESCUE HELO")
blueRescueHelo:SetTakeoffHot()
blueRescueHelo:Start()

env.info("Rescue Helo loaded...")
trigger.action.outText("Rescue Helo loaded ...", 10)

-- CAPTURE ZONES AND GROUND UNITS SPAWNING ***
RedGroundGroups = { "RED ASSAULT1", "RED ASSAULT2", "RED ASSAULT3", "RED ASSAULT4" }
BlueGroundGroups = { "BLUE ASSAULT1", "BLUE ASSAULT2", "BLUE ASSAULT3", "BLUE ASSAULT4" }

function Mission.spawnRedAlfa()
    RED_ALFA = SPAWN
            :New("RED ALFA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(RedGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if BLUE_ALFA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.RED, "ALFA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.RED, "ALFA is under air attack ", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        end
                    end
                    if MooseGroup:GetSize() == 1 then
                        BLUE_ALFA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

function Mission.spawnRedBeta()
    RED_BETA = SPAWN
            :New("RED BETA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(RedGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if BLUE_BETA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.RED, "BETA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.RED, "BETA is under air attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        end
                    end
                    if MooseGroup:GetSize() == 1 then
                        Mission.betaZoneGroups = nil
                        BLUE_BETA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

function Mission.spawnRedGamma()
    RED_GAMMA = SPAWN
            :New("RED GAMMA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(RedGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if BLUE_GAMMA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.RED, "GAMMA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.RED, "GAMMA is under air attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie2.ogg")
                        end
                    end
                    if MooseGroup:GetSize() == 1 then
                        Mission.gammaZoneGroups = nil
                        BLUE_GAMMA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

function Mission.spawnBlueAlfa()
    BLUE_ALFA = SPAWN
            :New("BLUE ALFA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(BlueGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if RED_ALFA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "ALFA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "ALFA is under air attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        end
                        if Mission.blueAlfaSmoke ~= true then
                            Mission.blueAlfaSmoke = true
                            MooseGroup:SmokeGreen()
                        end
                    end
                    MooseGroup:FlareGreen()
                    if MooseGroup:GetSize() == 1 then
                        RED_ALFA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

function Mission.spawnBlueBeta()
    BLUE_BETA = SPAWN
            :New("BLUE BETA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(BlueGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if RED_BETA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "BETA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "BETA is under air attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        end
                        if Mission.blueBetaSmoke ~= true then
                            Mission.blueBetaSmoke = true
                            MooseGroup:SmokeGreen()
                        end
                    end
                    MooseGroup:FlareGreen()
                    if MooseGroup:GetSize() == 1 then
                        RED_BETA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

function Mission.spawnBlueGamma()
    BLUE_GAMMA = SPAWN
            :New("BLUE GAMMA ASSAULT")
            :InitLimit(8, 0)
            :InitRandomizeRoute(4, 0, 200)
            :InitRandomizeTemplate(BlueGroundGroups)
            :OnSpawnGroup(
            function(MooseGroup)
                MooseGroup:HandleEvent(EVENTS.Dead)
                function MooseGroup:OnEventDead(EventData)
                    if MooseGroup:GetSize() < 4 then
                        if RED_GAMMA:IsAlive() then
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "GAMMA is under attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        else
                            trigger.action.outTextForCoalition(coalition.side.BLUE, "GAMMA is under air attack", 30)
                            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        end
                        if Mission.blueGammaSmoke ~= true then
                            Mission.blueGammaSmoke = true
                            MooseGroup:SmokeGreen()
                        end
                    end
                    MooseGroup:FlareGreen()
                    if MooseGroup:GetSize() == 1 then
                        RED_GAMMA:RouteResume()
                    end
                end
            end)
            :Spawn()
end

Mission.spawnRedAlfa()
Mission.spawnRedBeta()
Mission.spawnRedGamma()
Mission.spawnBlueAlfa()
Mission.spawnBlueBeta()
Mission.spawnBlueGamma()

RED_ALFA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()
            if RED_ALFA:IsAlive() ~= true then
                Mission.spawnRedAlfa()
            end
        end, {}, 0, 600, 0)

RED_BETA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()
            if RED_BETA:IsAlive() ~= true then
                Mission.spawnRedBeta()
            end
        end, {}, 0, 600, 0)

RED_GAMMA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()
            if RED_GAMMA:IsAlive() ~= true then
                Mission.spawnRedGamma()
            end
        end, {}, 0, 600, 0)

BLUE_ALFA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()
            if BLUE_ALFA:IsAlive() ~= true then
                Mission.spawnBlueAlfa()
            end
        end, {}, 0, 600, 0)

BLUE_BETA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()

            if BLUE_BETA:IsAlive() ~= true then
                Mission.spawnBlueBeta()
            end
        end, {}, 0, 600, 0)

BLUE_GAMMA_UNITS_SCHEDULER = SCHEDULER:New(nil,
        function()
            if BLUE_GAMMA:IsAlive() ~= true then
                Mission.spawnBlueGamma()
            end
        end, {}, 0, 600, 0)

function Mission.blueUnitsFlare(groupId)
    if BLUE_ALFA:IsAlive() then
        BLUE_ALFA:FlareGreen()
    end
    if BLUE_BETA:IsAlive() then
        BLUE_BETA:FlareGreen()
    end
    if BLUE_GAMMA:IsAlive() then
        BLUE_GAMMA:FlareGreen()
    end
    trigger.action.outTextForGroup(groupId, "Shooting GREEN flares now", 10, false)
    trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
end

function Mission.redUnitsFlare(groupId)
    if RED_ALFA:IsAlive() then
        RED_ALFA:FlareRed()
    end
    if RED_BETA:IsAlive() then
        RED_BETA:FlareRed()
    end
    if RED_GAMMA:IsAlive() then
        RED_GAMMA:FlareRed()
    end
    trigger.action.outTextForGroup(groupId, "Shooting RED flares now", 10, false)
    trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
end


-- BRIDGES (too far :-) ) ***
AlfaBridgeZone = ZONE_POLYGON:NewFromGroupName("BRIDGE ALFA ZONE")
AlfaBridgeSceneryElements = SCENERY:FindAllByZoneName(AlfaBridgeZone:GetName())

BetaBridgeZone = ZONE_POLYGON:NewFromGroupName("BRIDGE BETA ZONE")
BetaBridgeSceneryElements = SCENERY:FindAllByZoneName(BetaBridgeZone:GetName())

GammaBridgeZone = ZONE_POLYGON:NewFromGroupName("BRIDGE GAMMA ZONE")
GammaBridgeSceneryElements = SCENERY:FindAllByZoneName(GammaBridgeZone:GetName())

BridgeLifePointsMonitor = SCHEDULER:New(nil,
        function()
            if not Mission.isAlfaBridgeDestroyed then
                local isBridgeDestroyed = Mission.isOneSceneryElementDead(AlfaBridgeSceneryElements)
                if isBridgeDestroyed then
                    BLUE_ALFA_UNITS_SCHEDULER:Stop()
                    RED_ALFA_UNITS_SCHEDULER:Start()
                    Mission.isAlfaBridgeDestroyed = true
                    trigger.action.outText("ALFA bridge destroyed", 10, false)
                    trigger.action.outSound("walkietalkie.ogg")
                end
            end
            if not Mission.isBetaBridgeDestroyed then
                local isBridgeDestroyed = Mission.isOneSceneryElementDead(BetaBridgeSceneryElements)
                if isBridgeDestroyed then
                    BLUE_BETA_UNITS_SCHEDULER:Stop()
                    RED_BETA_UNITS_SCHEDULER:Start()
                    Mission.isBetaBridgeDestroyed = true
                    trigger.action.outText("BETA bridge destroyed", 10, false)
                    trigger.action.outSound("walkietalkie.ogg")
                end

            end
            if not Mission.isGammaBridgeDestroyed then
                local isBridgeDestroyed = Mission.isOneSceneryElementDead(GammaBridgeSceneryElements)
                if isBridgeDestroyed then
                    BLUE_GAMMA_UNITS_SCHEDULER:Start()
                    RED_GAMMA_UNITS_SCHEDULER:Stop()
                    Mission.isGammaBridgeDestroyed = true
                    trigger.action.outText("GAMMA bridge destroyed", 10, false)
                    trigger.action.outSound("walkietalkie.ogg")
                end
            end
        end, {}, 0, 60, 0)

function Mission.isOneSceneryElementDead(sceneryElementsTable)
    --env.info("Scenery elements table " .. UTILS.PrintTableToLog(sceneryElementsTable))
    for i = 1, #sceneryElementsTable do
        local bridgeElement = sceneryElementsTable[i]
        --env.info("Bridge element SceneryName " .. bridgeElement.SceneryName)
        --env.info("Bridge element SceneryObject.id_ " .. bridgeElement.SceneryObject.id_)
        --env.info("Bridge element initial life " .. bridgeElement:GetLife0())
        --env.info("Bridge element current life " .. bridgeElement:GetLife())
        local elementLifePoints = bridgeElement:GetLife()
        if elementLifePoints == 0 then
            return true
        end
    end
    return false
end

function Mission.getBridgeStatus(groupId)

    local bridgeReport = REPORT:New()

    if Mission.isAlfaBridgeDestroyed then
        bridgeReport:Add("ALFA bridge is destroyed")
    else
        bridgeReport:Add("ALFA bridge is ok")
    end

    if Mission.isBetaBridgeDestroyed then
        bridgeReport:Add("BETA bridge is destroyed")
    else
        bridgeReport:Add("BETA bridge is ok")
    end

    if Mission.isGammaBridgeDestroyed then
        bridgeReport:Add("GAMMA bridge is destroyed")
    else
        bridgeReport:Add("GAMMA bridge is ok")
    end
    trigger.action.outTextForGroup(groupId, bridgeReport:Text(), 10, false)
    trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
end

-- CAPTURE ZONES ***
AlfaZone = ZONE:FindByName("ALFA")
AlfaCaptureZone = ZONE_CAPTURE_COALITION:New(AlfaZone, coalition.side.RED)
BetaZone = ZONE:FindByName("BETA")
BetaCaptureZone = ZONE_CAPTURE_COALITION:New(BetaZone, coalition.side.RED)
GammaZone = ZONE:FindByName("GAMMA")
GammaCaptureZone = ZONE_CAPTURE_COALITION:New(GammaZone, coalition.side.RED)

function AlfaCaptureZone:OnEnterGuarded(From, Event, To)
    Mission.AlfaZoneStatus = "Guarded"
end

function AlfaCaptureZone:OnEnterEmpty()
    Mission.AlfaZoneStatus = "Empty"
    if BLUE_ALFA:IsAlive() == true then
        BLUE_ALFA:RouteResume()
    end
    if RED_ALFA:IsAlive() == true then
        RED_ALFA:RouteResume()
    end
end

function AlfaCaptureZone:OnEnterAttacked()
    Mission.AlfaZoneStatus = "Attacked"
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("RED coalition attacking ALFA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_ALFA:IsAlive() == true then
            BLUE_ALFA:RouteStop()
        end
    else
        trigger.action.outText("BLUE coalition attacking ALFA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_ALFA:IsAlive() == true then
            RED_ALFA:RouteStop()
        end
    end
end

function AlfaCaptureZone:OnEnterCaptured()
    Mission.AlfaZoneStatus = "Captured"
    trigger.action.outSound("walkietalkie2.ogg")
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("BLUE coalition captured ALFA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_ALFA:IsAlive() == true then
            RED_ALFA:RouteStop()
        end
    else
        trigger.action.outText("RED coalition captured ALFA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_ALFA:IsAlive() == true then
            BLUE_ALFA:RouteStop()
        end
    end

    self:__Guard(30)
end

AlfaCaptureZone:__Guard(1)
AlfaCaptureZone:Start(30, 120)

function BetaCaptureZone:OnEnterGuarded(From, Event, To)
    Mission.BetaZoneStatus = "Guarded"
end

function BetaCaptureZone:OnEnterEmpty()
    Mission.BetaZoneStatus = "Empty"
    if BLUE_BETA:IsAlive() == true then
        BLUE_BETA:RouteResume()
    end
    if RED_BETA:IsAlive() == true then
        RED_BETA:RouteResume()
    end
end

function BetaCaptureZone:OnEnterAttacked()
    Mission.BetaZoneStatus = "Attacked"
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("RED coalition attacking BETA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_BETA:IsAlive() == true then
            BLUE_BETA:RouteStop()
        end
    else
        trigger.action.outText("BLUE coalition attacking BETA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_BETA:IsAlive() == true then
            RED_BETA:RouteStop()
        end
    end
end

function BetaCaptureZone:OnEnterCaptured()
    Mission.BetaZoneStatus = "Captured"
    trigger.action.outSound("walkietalkie2.ogg")
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("BLUE coalition captured BETA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_BETA:IsAlive() == true then
            RED_BETA:RouteStop()
        end
    else
        trigger.action.outText("RED coalition captured BETA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_BETA:IsAlive() == true then
            BLUE_BETA:RouteStop()
        end
    end

    self:__Guard(30)
end

BetaCaptureZone:__Guard(1)
BetaCaptureZone:Start(30, 120)

function GammaCaptureZone:OnEnterGuarded(From, Event, To)
    Mission.GammaZoneStatus = "Guarded"
end

function GammaCaptureZone:OnEnterEmpty()
    Mission.GammaZoneStatus = "Empty"
    if BLUE_GAMMA:IsAlive() == true then
        BLUE_GAMMA:RouteResume()
    end
    if RED_GAMMA:IsAlive() == true then
        RED_GAMMA:RouteResume()
    end
end

function GammaCaptureZone:OnEnterAttacked()
    Mission.GammaZoneStatus = "Attacked"
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("RED coalition attacking GAMMA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_GAMMA:IsAlive() == true then
            BLUE_GAMMA:RouteStop()
        end
    else
        trigger.action.outText("BLUE coalition attacking GAMMA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_GAMMA:IsAlive() == true then
            RED_GAMMA:RouteStop()
        end
    end
end

function GammaCaptureZone:OnEnterCaptured()
    Mission.GammaZoneStatus = "Captured"
    trigger.action.outSound("walkietalkie2.ogg")
    local Coalition = self:GetCoalition()
    self:E({ Coalition = Coalition })
    if Coalition == coalition.side.BLUE then
        trigger.action.outText("BLUE coalition captured GAMMA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if RED_GAMMA:IsAlive() == true then
            RED_GAMMA:RouteStop()
        end
    else
        trigger.action.outText("RED coalition captured GAMMA", 10, false)
        trigger.action.outSound("walkietalkie.ogg")
        if BLUE_GAMMA:IsAlive() == true then
            BLUE_GAMMA:RouteStop()
        end
    end

    self:__Guard(30)
end

GammaCaptureZone:__Guard(1)
GammaCaptureZone:Start(30, 120)

env.info("Mission CAPTURE ZONES loaded ...")
trigger.action.outText("Mission CAPTURE ZONES loaded ...", 10)

-- CHECK CZ STATUS FUNCTIONS ***

function Mission.getCaptureZoneStatus(groupId)
    local alfaCoalition = AlfaCaptureZone:GetCoalition()
    local betaCoalition = BetaCaptureZone:GetCoalition()
    local gammaCoalition = GammaCaptureZone:GetCoalition()

    local captureZoneStatusReport = REPORT:New()

    if alfaCoalition == coalition.side.BLUE then
        captureZoneStatusReport:Add(string.format("ALFA is BLUE, %s", Mission.AlfaZoneStatus))
    else
        captureZoneStatusReport:Add(string.format("ALFA is RED, %s", Mission.AlfaZoneStatus))
    end

    if betaCoalition == coalition.side.BLUE then
        captureZoneStatusReport:Add(string.format("BETA is BLUE, %s", Mission.BetaZoneStatus))
    else
        captureZoneStatusReport:Add(string.format("BETA is RED, %s", Mission.BetaZoneStatus))
    end

    if gammaCoalition == coalition.side.BLUE then
        captureZoneStatusReport:Add(string.format("GAMMA is BLUE, %s", Mission.GammaZoneStatus))
    else
        captureZoneStatusReport:Add(string.format("GAMMA is RED, %s", Mission.GammaZoneStatus))
    end

    trigger.action.outTextForGroup(groupId, captureZoneStatusReport:Text(), 10, false)
    trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
end

env.info("Mission CAPTURE ZONE STATUS FUNCTIONS loaded ...")
trigger.action.outText("Mission CAPTURE ZONE STATUS FUNCTIONS loaded ...", 10)

-- AFAC Red ***
redDetectedGroups = {}
redObservers = SET_GROUP:New():FilterPrefixes({ "RED ALFA", "RED BETA", "RED GAMMA" }):FilterStart()
redObserversDetection = DETECTION_AREAS:New(redObservers, 2000):FilterCategories(Unit.Category.GROUND_UNIT)
redObserversDetection:BoundDetectedZones()
redObserversDetection:Start()

-- this is like @Override, we are overriding OnAfterDetected here
function redObserversDetection:OnAfterDetected(From, Event, To, Units)

    for index, unit in pairs(Units) do
        -- store target in a global variable
        local detectedGroup = unit:GetGroup()
        local detectedGroupId = detectedGroup:GetID()
        local isNewTarget = false
        if redDetectedGroups[detectedGroupId] == nil then
            redDetectedGroups[detectedGroupId] = detectedGroup
            isNewTarget = true
        end
        local groupCoordinate = detectedGroup:GetVec2()
        local targetInZone = nil
        if AlfaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = AlfaZone:GetName()
        elseif BetaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = BetaZone:GetName()
        elseif GammaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = GammaZone:GetName()
        end
        if isNewTarget == true and targetInZone ~= nil then
            trigger.action.outTextForCoalition(coalition.side.RED, "Ground units found in " .. targetInZone, 15)
            trigger.action.outSoundForCoalition(coalition.side.RED, "walkietalkie.ogg")
        end

        --env.info("Detected " .. detectedGroup:GetID() .. " name " .. detectedGroup:GetName() .. " in zone " .. targetInZone)
        --trigger.action.outText("Detected " .. detectedGroup:GetID() .. " name " .. detectedGroup:GetName() .. " in zone " .. targetInZone, 10)
    end
end

-- AFAC *** (controllable)
blueAfacDetectedGroups = {}
blueObservers = SET_GROUP:New():FilterPrefixes({ "BLUE AFAC", "BLUE ALFA", "BLUE BETA", "BLUE GAMMA" }):FilterStart()
blueObserversDetection = DETECTION_AREAS:New(blueObservers, 2000):FilterCategories(Unit.Category.GROUND_UNIT)
blueObserversDetection:BoundDetectedZones()
blueObserversDetection:Start()

-- this is like @Override, we are overriding OnAfterDetected here
function blueObserversDetection:OnAfterDetected(From, Event, To, Units)
    for index, unit in pairs(Units) do
        -- store target in a global variable
        local detectedGroup = unit:GetGroup()
        local detectedGroupId = detectedGroup:GetID()
        local isNewTarget = false
        if blueAfacDetectedGroups[detectedGroupId] == nil then
            blueAfacDetectedGroups[detectedGroupId] = detectedGroup
            isNewTarget = true
        end
        local groupCoordinate = detectedGroup:GetVec2()
        local targetInZone = nil
        if AlfaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = AlfaZone:GetName()
        elseif BetaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = BetaZone:GetName()
        elseif GammaZone:IsVec2InZone(groupCoordinate) then
            targetInZone = GammaZone:GetName()
        end
        if isNewTarget == true and targetInZone ~= nil then
            trigger.action.outTextForCoalition(coalition.side.BLUE, "CAS Tasking in " .. targetInZone, 15)
            trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie.ogg")
        end

        --env.info("Detected " .. detectedGroup:GetID() .. " name " .. detectedGroup:GetName() .. " in zone " .. targetInZone)
        --trigger.action.outText("Detected " .. detectedGroup:GetID() .. " name " .. detectedGroup:GetName() .. " in zone " .. targetInZone, 10)
    end
    -- get target coordinate and orbit above it
    --local groupCoordinate = BLUE_OBSERVER_DETECTED_GROUP:GetVec2()
    --local blueObserverOrbitTask = BLUE_OBSERVER:TaskOrbitCircleAtVec2(groupCoordinate, 2000, 500)
    --BLUE_OBSERVER:PushTask(blueObserverOrbitTask, 0)
    -- stop detection until player does his stuff and then detection will resume when player invokes Mission.afacResumePatrol()
    --timer.scheduleFunction(Mission.afacStopDetection, {}, timer.getTime() + 15)
end

function Mission.afacStartDetection()
    blueObserversDetection:Start()
end

function Mission.afacGetReport(groupId, playerCoalition)
    -- COORDINATE:ToStringBULLS(Coalition, Settings, MagVar)
    -- COORDINATE:ToStringMGRS(Settings)
    local hasReport = false

    if playerCoalition == coalition.side.BLUE then
        if RED_ALFA ~= nil and RED_ALFA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(AlfaZone:GetName(), RED_ALFA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
        if RED_BETA ~= nil and RED_BETA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(BetaZone:GetName(), RED_BETA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
        if RED_GAMMA ~= nil and RED_GAMMA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(GammaZone:GetName(), RED_GAMMA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
    else
        if BLUE_ALFA ~= nil and BLUE_ALFA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(AlfaZone:GetName(), BLUE_ALFA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
        if BLUE_BETA ~= nil and BLUE_BETA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(BetaZone:GetName(), BLUE_BETA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
        if BLUE_GAMMA ~= nil and BLUE_GAMMA:IsAlive() then
            local detectedTargetReport = Mission.getDetectedGroupReport(GammaZone:GetName(), BLUE_GAMMA, playerCoalition)
            trigger.action.outTextForGroup(groupId, detectedTargetReport:Text(), 15, false)
            hasReport = true
        end
    end


    --local detectionReport = blueObserversDetection:DetectedReportDetailed()
    --trigger.action.outTextForGroup(groupId, detectionReport, 30 , false)
    if hasReport == false then
        trigger.action.outTextForGroup(groupId, "No targets at the moment", 15, false)
    end
    trigger.action.outSoundForCoalition(playerCoalition.side.BLUE, "walkietalkie2.ogg")
end

function Mission.getDetectedGroupReport(zoneName, detectedGroup, playerCoalition)

    local detectedItemsCount = detectedGroup:CountAliveUnits()
    local detectedItemCoordinate = detectedGroup:GetCoordinate()
    local detectedItemCoordText
    if playerCoalition == coalition.side.BLUE then
        detectedItemCoordText  = detectedItemCoordinate:ToStringBULLS(coalition.side.BLUE)
    else
        detectedItemCoordText  = detectedItemCoordinate:ToStringBULLS(coalition.side.RED)
    end

    local unitTypes = ""
    local detectedUnits = detectedGroup:GetUnits()
    for i = 1, #detectedUnits do
        local detectedUnit = detectedGroup:GetUnit(i)
        if i < #detectedUnits then
            unitTypes = unitTypes .. detectedUnit:GetTypeName() .. ", "
        else
            unitTypes = unitTypes .. detectedUnit:GetTypeName()
        end
    end

    local detectedGroupReport = REPORT:New()
    detectedGroupReport:Add(zoneName)
    detectedGroupReport:Add(string.format("%s", detectedItemCoordText))
    detectedGroupReport:Add(string.format("%s", unitTypes))
    detectedGroupReport:Add(string.format("Altitude %2d ft, QFE %2d hpa |  %.2f inhg",
            detectedGroup:GetAltitude() * 3.28,
            detectedItemCoordinate:GetPressure(0),
            detectedItemCoordinate:GetPressure(0) / 33.86))
    return detectedGroupReport
end

function Mission.afacSmokeTarget(groupId, zoneToSmokeTarget)
    if zoneToSmokeTarget == AlfaZone:GetName() then
        Mission.afacSmokeTargetPushTask(groupId, zoneToSmokeTarget, RED_ALFA)
    elseif zoneToSmokeTarget == BetaZone:GetName() then
        Mission.afacSmokeTargetPushTask(groupId, zoneToSmokeTarget, RED_BETA)
    elseif (zoneToSmokeTarget == GammaZone:GetName()) then
        Mission.afacSmokeTargetPushTask(groupId, zoneToSmokeTarget, RED_GAMMA)
    end
end

function Mission.afacSmokeTruckParking(groupId)
    if RED_TRUCK_PARKING ~= nil and RED_TRUCK_PARKING:IsAlive() then
        if pcall(Mission.afacSmokeTaskPush, RED_TRUCK_PARKING, nil, AI.Task.WeaponExpend.ONE, 1, nil, 2000, true) then
            env.info("SUCCESS smoke target in RED_TRUCK_PARKING")
        else
            env.info("ERROR smoke target in RED_TRUCK_PARKING")
        end
        trigger.action.outTextForGroup(groupId, "AFAC marking Truck Parking", 30, false)
        trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
    else
        trigger.action.outTextForGroup(groupId, "Truck parking not detected", 30, false)
        trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
    end
end

function Mission.afacSmokeTargetPushTask(groupId, zoneToSmokeTarget, targetGroupToSmoke)
    if targetGroupToSmoke ~= nil and targetGroupToSmoke:IsAlive() then
        if pcall(Mission.afacSmokeTaskPush, targetGroupToSmoke, nil, AI.Task.WeaponExpend.ONE, 1, nil, 2000, true) then
            env.info("SUCCESS smoke target in " .. zoneToSmokeTarget)
        else
            env.info("ERROR smoke target in " .. zoneToSmokeTarget)
        end
        trigger.action.outTextForGroup(groupId, "AFAC running in " .. zoneToSmokeTarget, 30, false)
        trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
    else
        trigger.action.outTextForGroup(groupId, "No targets in " .. zoneToSmokeTarget, 30, false)
        trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
    end
end

-- call this with pcall(!) to avoid CTD
function Mission.afacSmokeTaskPush(
        groupToSmoke,
        weaponType,
        weaponToExpend,
        howManyAttacks,
        attackDirection,
        attackAltitude,
        isAttackLimited)

    local afacTaskToPush = BLUE_OBSERVER:TaskAttackGroup(
            groupToSmoke,
            weaponType,
            weaponToExpend,
            howManyAttacks,
            attackDirection,
            attackAltitude,
            isAttackLimited)
    BLUE_OBSERVER:PushTask(afacTaskToPush, 0)
end

function Mission.spawnBlueAfac(groupId)
    if Mission.blueAfacRunning == false then
        BLUE_OBSERVER = SPAWN
                :New("BLUE AFAC")
                :InitLimit(1, 0)
                :InitRepeatOnLanding()
                :OnSpawnGroup(
                function(MooseGroup)

                    Mission.afacStartDetection()
                    MooseGroup:HandleEvent(EVENTS.Dead)
                    MooseGroup:HandleEvent(EVENTS.Land)
                    MooseGroup:HandleEvent(EVENTS.Shot)

                    function MooseGroup:OnEventDead(EventData)
                        Mission.blueAfacRunning = false
                    end

                    function MooseGroup:OnEventLand(EventData)
                        trigger.action.outTextForCoalition(coalition.side.BLUE, "AFAC returned to base", 30, false)
                        trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                        Mission.blueAfacRunning = false
                        MooseGroup:Destroy()
                    end

                    function MooseGroup:OnEventShot(self, EventData)
                        trigger.action.outTextForCoalition(coalition.side.BLUE, "Smoke out", 30, false)
                        trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie2.ogg")
                    end
                end)
                :Spawn()

        Mission.blueAfacRunning = true
        trigger.action.outTextForCoalition(coalition.side.BLUE, "AFAC enroute to patrol area", 30, false)
        trigger.action.outSoundForCoalition(coalition.side.BLUE, "walkietalkie.ogg")
    else
        if BLUE_OBSERVER:IsAlive() then
            trigger.action.outTextForGroup(groupId, "AFAC already in flight", 10, false)
            trigger.action.outSoundForGroup(groupId, "walkietalkie.ogg")
        else
            Mission.blueAfacRunning = false
            Mission.spawnBlueAfac()
        end
    end
end

env.info("AFAC loaded...")
trigger.action.outText("AFAC loaded ...", 10)

-- MAP COORDINATES ***

RED_DEPOT = STATIC:FindByName("RED DEPOT", true)
local RED_DEPOT_COORDS = RED_DEPOT:GetCoordinate()
RED_DEPOT_COORDS:MarkToAll("RED LOGISTIC CENTER", true, nil)

env.info("MAP COORDINATES loaded ...")
trigger.action.outText("MAP COORDINATES loaded ...", 10)

-- STRATEGIC TARGETS ***

RED_TRUCK_PARKING_ZONES = {
    ZONE:FindByName("RED TRUCK PARKING SPAWN1"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN2"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN3"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN4"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN5"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN6"),
    ZONE:FindByName("RED TRUCK PARKING SPAWN7") }

function Mission.spawnRedTruckParkings()
    RED_TRUCK_PARKING = SPAWN
            :New("RED TRUCK PARKING")
            :InitRandomizeZones(RED_TRUCK_PARKING_ZONES)
            :OnSpawnGroup(
            function(MooseGroup)
                local MooseGroupCoordinate = MooseGroup:GetCoordinate()
                local markId = MooseGroupCoordinate:MarkToAll("Suspect Truck Parking", true, nil)
                Mission.mapMarkRedBarracks = markId

                RED_ALFA_UNITS_SCHEDULER:Start()
                RED_BETA_UNITS_SCHEDULER:Start()
                RED_GAMMA_UNITS_SCHEDULER:Start()
                trigger.action.outText("Suspect Truck Parking found, see map", 10)
                trigger.action.outSound("walkietalkie.ogg")

                MooseGroup:HandleEvent(EVENTS.Dead)

                function MooseGroup:OnEventDead(EventData)
                    if RED_TRUCK_PARKING:GetSize() < 10 then
                        trigger.action.removeMark(Mission.mapMarkRedBarracks)
                        RED_ALFA_UNITS_SCHEDULER:Stop()
                        RED_BETA_UNITS_SCHEDULER:Stop()
                        RED_GAMMA_UNITS_SCHEDULER:Stop()
                        RED_TRUCK_PARKING:Destroy(false)
                        trigger.action.outText("Suspect Truck Parking destroyed, no ground units for 30 minutes", 15)
                        trigger.action.outSound("walkietalkie.ogg")
                        timer.scheduleFunction(Mission.spawnRedTruckParkings, {}, timer.getTime() + 1800)
                    end
                end
            end)
            :Spawn()
    RED_ALFA_UNITS_SCHEDULER:Start()
    RED_BETA_UNITS_SCHEDULER:Start()
    RED_GAMMA_UNITS_SCHEDULER:Start()
end

Mission.spawnRedTruckParkings()

env.info("STRATEGIC TARGETS loaded ...")
trigger.action.outText("STRATEGIC TARGETS loaded ...", 10)

-- AIRSPACES
blueAirspace = ZONE_POLYGON:NewFromGroupName("BLUE AIRSPACE")
redAirspace = ZONE_POLYGON:NewFromGroupName("RED AIRSPACE")

-- MANTIS
blueMantis = MANTIS:New(
        "BlueMantis",
        "BLUE SAM",
        nil, -- no EWR prefix for blue
        "Blue HQ", -- no HQ
        "blue",
        true, -- is dynamic filter, new units will be added to mantis
        "BLUE AWACS",
        true, -- make switch emissions on or off instead of changing state from RED to GREEN
        0, -- number of seconds to wait before switching on radar again
        nil) -- zones, for something not clear
blueMantis:Start()
redMantis = MANTIS:New(
        "RedMantis",
        "RED SAM",
        "RED EWR",
        "Red", -- no HQ
        "red",
        false, -- is not dynamic filter, new units will not be added to mantis
        nil, -- no AWACS
        true, -- make switch emissions on or off instead of changing state from RED to GREEN
        0, -- number of seconds to wait before switching on radar again
        nil) -- zones, for something not clear
redMantis:Start()

-- Blue A2A
blueAirDispatcher = AI_A2A_DISPATCHER:New(blueMantis.Detection)
blueAirDispatcher:SetCommandCenter(blueCC)
blueAirDispatcher:SetTacticalDisplay(false)
blueAirDispatcher:SetBorderZone(blueAirspace)
blueAirDispatcher:SetEngageRadius(100000)

blueAirDispatcher:SetSquadron("USN CAP", Mission.cvn71UnitName, { "BLUE F-14A CAP" }, 32)
blueAirDispatcher:SetSquadronOverhead("USN CAP", 1)
blueAirDispatcher:SetSquadronGrouping("USN CAP", 2)
blueAirDispatcher:SetSquadronTakeoffInAir("USN CAP", 1000)
blueAirDispatcher:SetSquadronLandingAtEngineShutdown("USN CAP")
blueAirDispatcher:SetSquadronCap("USN CAP", blueAirspace, 5000, 8000, 800, 950, 1000, "BARO")
blueAirDispatcher:SetSquadronTanker("USN CAP", "BLUE TANKER")

blueAirDispatcher:SetSquadron("USAF CAP", AIRBASE.Caucasus.Batumi, { "BLUE F-5 CAP", "BLUE F-4 CAP" }, 32)
blueAirDispatcher:SetSquadronOverhead("USAF CAP", 1)
blueAirDispatcher:SetSquadronGrouping("USAF CAP", 2)
blueAirDispatcher:SetSquadronTakeoffInAir("USAF CAP", 500)
blueAirDispatcher:SetSquadronLandingAtEngineShutdown("USAF CAP")
blueAirDispatcher:SetSquadronCap("USAF CAP", blueAirspace, 5000, 8000, 800, 950, 1000, "BARO")
blueAirDispatcher:SetSquadronTanker("USAF CAP", "BLUE TANKER")

-- Blue A2G
-- Let the RecceSetGroup vehicles in the collection detect targets and group them in AREAS of 1000 meters.
BlueGroundDispatcher = AI_A2G_DISPATCHER:New(blueObserversDetection)
BlueGroundDispatcher:SetCommandCenter(blueCC)
BlueGroundDispatcher:SetTacticalDisplay(false)
BlueGroundDispatcher:AddDefenseCoordinate("Alfa", AlfaZone:GetCoordinate())
BlueGroundDispatcher:AddDefenseCoordinate("Beta", BetaZone:GetCoordinate())
BlueGroundDispatcher:AddDefenseCoordinate("Gamma", GammaZone:GetCoordinate())
BlueGroundDispatcher:SetDefenseReactivityLow() -- Low defense reactivity. So far proximity of a threat **MAY** (not WILL) trigger a defense action.
BlueGroundDispatcher:SetDefenseRadius(200000) -- Defense radius wide enough to also trigger defenses far away.

-- set USN CAS
BlueGroundDispatcher:SetSquadron("USN CAS", Mission.cvn71UnitName, { "BLUE CAS A-4 USN" }, 16)
BlueGroundDispatcher:SetSquadronCas("USN CAS", 800, 950, 1000, 5000)
BlueGroundDispatcher:SetSquadronTakeoffInAir("USN CAS", 1000)
BlueGroundDispatcher:SetSquadronLandingAtEngineShutdown("USN CAS")
BlueGroundDispatcher:SetSquadronOverhead("USN CAS", 0.5)
BlueGroundDispatcher:SetSquadronCasPatrolInterval("USN CAS", 2)
-- set USN BAI
BlueGroundDispatcher:SetSquadron("USN BAI", Mission.cvn71UnitName, { "BLUE CAS A-4 USN" }, 16)
BlueGroundDispatcher:SetSquadronBai("USN BAI", 800, 950, 1000, 5000)
BlueGroundDispatcher:SetSquadronTakeoffInAir("USN BAI", 1000)
BlueGroundDispatcher:SetSquadronLandingAtEngineShutdown("USN BAI")
BlueGroundDispatcher:SetSquadronOverhead("USN BAI", 0.5)
BlueGroundDispatcher:SetSquadronBaiPatrolInterval("USN BAI", 2)

-- set Batumi CAS
BlueGroundDispatcher:SetSquadron("Batumi CAS", AIRBASE.Caucasus.Batumi,
        { "BLUE CAS A-4", "BLUE CAS F-4", "BLUE CAS L-39", "BLUE CAS F-5" }, 16)
BlueGroundDispatcher:SetSquadronCas("Batumi CAS", 800, 950, 1000, 5000)
BlueGroundDispatcher:SetSquadronTakeoffInAir("Batumi CAS", 500)
BlueGroundDispatcher:SetSquadronLandingAtEngineShutdown("Batumi CAS")
BlueGroundDispatcher:SetSquadronOverhead("Batumi CAS", 0.5)
BlueGroundDispatcher:SetSquadronCasPatrolInterval("Batumi CAS", 2)
-- set Batumi BAI
BlueGroundDispatcher:SetSquadron("Batumi BAI", AIRBASE.Caucasus.Batumi,
        { "BLUE CAS A-4", "BLUE CAS F-4", "BLUE CAS L-39", "BLUE CAS F-5" }, 16)
BlueGroundDispatcher:SetSquadronBai("Batumi BAI", 800, 950, 1000, 5000)
BlueGroundDispatcher:SetSquadronTakeoffInAir("Batumi BAI", 500)
BlueGroundDispatcher:SetSquadronLandingAtEngineShutdown("Batumi BAI")
BlueGroundDispatcher:SetSquadronOverhead("Batumi BAI", 0.5)
BlueGroundDispatcher:SetSquadronBaiPatrolInterval("Batumi BAI", 2)
-- set FARP CAS
BlueGroundDispatcher:SetSquadron("BLUE FARP CAS", "BLUE FARP MADRID", { "BLUE HELI ATTACK" }, 16)
BlueGroundDispatcher:SetSquadronBai("BLUE FARP CAS", 200, 300, 200, 500)
BlueGroundDispatcher:SetSquadronTakeoffInAir("BLUE FARP CAS", 500)
BlueGroundDispatcher:SetSquadronLandingAtEngineShutdown("BLUE FARP CAS")
BlueGroundDispatcher:SetSquadronOverhead("BLUE FARP CAS", 0.25)
BlueGroundDispatcher:SetSquadronTakeoffInterval("BLUE FARP CAS", 60)

-- Red A2A
RedAirDispatcher = AI_A2A_DISPATCHER:New(redMantis.Detection)
RedAirDispatcher:SetCommandCenter(redCC)
RedAirDispatcher:SetTacticalDisplay(false)
RedAirDispatcher:SetBorderZone(redAirspace)
RedAirDispatcher:SetEngageRadius(150000)
RedAirDispatcher:SetSquadron("Gudauta GCI", AIRBASE.Caucasus.Gudauta,
        { "RED MIG-19 CAP HH", "RED MIG-19 CAP GG", "RED MIG-21 CAP HH", "RED MIG-21 CAP GG", "RED MIG-23 CAP GG", "RED MIG-23 CAP HH" }, 32)
RedAirDispatcher:SetSquadronOverhead("Gudauta GCI", 0.25)
RedAirDispatcher:SetSquadronGrouping("Gudauta GCI", 1)
RedAirDispatcher:SetSquadronTakeoffInAir("Gudauta GCI", 500)
RedAirDispatcher:SetSquadronLandingAtEngineShutdown("Gudauta GCI")
RedAirDispatcher:SetSquadronGci("Gudauta GCI", 900, 1200)

-- Red A2G
RedA2GDetectionSetGroup = SET_GROUP:New()
RedA2GDetectionSetGroup:FilterPrefixes({ "RED ALFA", "RED BETA", "RED GAMMA", "RED TSK" })
RedA2GDetectionSetGroup:FilterStart()
RedA2GDetection = DETECTION_AREAS:New(RedA2GDetectionSetGroup, 20000)
RedA2GDetection:SetFriendliesRange(20000)

RedGroundDispatcher = AI_A2G_DISPATCHER:New(RedA2GDetection)
RedGroundDispatcher:SetCommandCenter(redCC)
RedGroundDispatcher:SetTacticalDisplay(false)
--RedGroundDispatcher:SetTacticalMenu( "Dispatchers", "Air-to-Ground" )
RedGroundDispatcher:AddDefenseCoordinate("Alfa", AlfaZone:GetCoordinate())
RedGroundDispatcher:AddDefenseCoordinate("Beta", BetaZone:GetCoordinate())
RedGroundDispatcher:AddDefenseCoordinate("Gamma", GammaZone:GetCoordinate())
RedGroundDispatcher:SetDefenseReactivityLow() -- Low defense reactivity. So far proximity of a threat **MAY** (not WILL) trigger a defense action.
RedGroundDispatcher:SetDefenseRadius(200000) -- Defense radius wide enough to also trigger defenses far away.
RedGroundDispatcher:SetSquadron("Gudauta BAI", AIRBASE.Caucasus.Gudauta,
        { "RED CAS MIG-27", "RED CAS SU-17", "RED CAS SU-25", "RED CAS L-39" }, 16)
RedGroundDispatcher:SetSquadronBai("Gudauta BAI", 800, 950, 1000, 5000)
RedGroundDispatcher:SetSquadronTakeoffInAir("Gudauta BAI", 500)
RedGroundDispatcher:SetSquadronLandingAtEngineShutdown("Gudauta BAI")
RedGroundDispatcher:SetSquadronOverhead("Gudauta BAI", 0.25)
RedGroundDispatcher:SetSquadronTakeoffInterval("Gudauta BAI", 60)

RedGroundDispatcher:SetSquadron("Gudauta CAS", AIRBASE.Caucasus.Gudauta,
        { "RED CAS MIG-27", "RED CAS SU-17", "RED CAS SU-25", "RED CAS L-39" }, 16)
RedGroundDispatcher:SetSquadronCas("Gudauta CAS", 800, 950, 1000, 5000)
RedGroundDispatcher:SetSquadronTakeoffInAir("Gudauta CAS", 3300)
RedGroundDispatcher:SetSquadronLandingAtEngineShutdown("Gudauta CAS")
RedGroundDispatcher:SetSquadronOverhead("Gudauta CAS", 0.25)
RedGroundDispatcher:SetSquadronTakeoffInterval("Gudauta CAS", 60)

RedGroundDispatcher:SetSquadron("RED FARP CAS", "RED FARP", { "RED HELI ATTACK" }, 16)
RedGroundDispatcher:SetSquadronCas("RED FARP CAS", 200, 300, 200, 500)
RedGroundDispatcher:SetSquadronTakeoffInAir("RED FARP CAS", 500)
RedGroundDispatcher:SetSquadronLandingAtEngineShutdown("RED FARP CAS")
RedGroundDispatcher:SetSquadronOverhead("RED FARP CAS", 0.25)
RedGroundDispatcher:SetSquadronTakeoffInterval("RED FARP CAS", 60)

env.info("Dispatchers loaded...")
trigger.action.outText("Dispatchers loaded ...", 10)

-- FARP ***
bluePlayerHeliGroupNames = "BLUE PLAYER HELI"
-- CTLD
local ctldBlue = CTLD:New(coalition.side.BLUE, { bluePlayerHeliGroupNames }, "BLUE Logistics")
ctldBlue.SmokeColor = SMOKECOLOR.Green -- default color to use when dropping smoke from heli 
ctldBlue.FlareColor = FLARECOLOR.Green -- color to use when flaring from heli
ctldBlue.RadioSound = "beacon.ogg" -- -- this sound will be hearable if you tune in the beacon frequency. Add the sound file to your miz.
ctldBlue.RadioSoundFC3 = "beaconsilent.ogg"
ctldBlue.dropcratesanywhere = true
ctldBlue.cratecountry = country.id.USA
ctldBlue:__Start(5)
ctldBlue:AddCTLDZone("BLUE FARP MADRID", CTLD.CargoZoneType.LOAD, SMOKECOLOR.Green, true, true)
ctldBlue:AddTroopsCargo("Infantry Team", { "BLUE FARP INFANTRY" }, CTLD_CARGO.Enum.TROOPS, 4, 100)
ctldBlue:AddTroopsCargo("Infantry RPG Team", { "BLUE FARP ANTI TANK TEAM" }, CTLD_CARGO.Enum.TROOPS, 4, 100)
ctldBlue:AddTroopsCargo("Mortar Team", { "BLUE FARP MORTAR TEAM" }, CTLD_CARGO.Enum.TROOPS, 4, 100)
ctldBlue:AddCratesCargo("Ammunitions", { "BLUE FARP AMMO TEAM" }, CTLD_CARGO.Enum.VEHICLE, 1, 250, nil)
ctldBlue:AddCratesCargo("M163 Vulcan", { "BLUE FARP AAA VULCAN" }, CTLD_CARGO.Enum.VEHICLE, 1, 500, nil)
ctldBlue:AddCratesCargo("M48 Chaparral", { "BLUE FARP AAA CHAPARRAL" }, CTLD_CARGO.Enum.VEHICLE, 1, 500, nil)

env.info("CTLD loaded...")
trigger.action.outText("CTLD loaded ...", 10)

-- CSAR
csarBlue = CSAR:New(coalition.side.BLUE, "BLUE DOWNED PILOT", "BLUE CSAR")
csarBlue.immortalcrew = true -- downed pilot spawn is immortal
csarBlue.invisiblecrew = true -- downed pilot spawn is visible
csarBlue.enableForAI = true -- enable for AI also
csarBlue.coordtype = 3 -- Use Lat/Long DDM (0), Lat/Long DMS (1), MGRS (2), Bullseye imperial (3) or Bullseye metric (4) for coordinates.
csarBlue.mashprefix = { "BLUE FARP" }
csarBlue.radioSound = "beacon.ogg"
csarBlue.smokecolor = 0 -- Color of smokemarker, 0 is green, 1 is red, 2 is white, 3 is orange and 4 is blue.
csarBlue.useprefix = true  -- Requires CSAR helicopter #GROUP names to have the prefix(es) defined below.
csarBlue.csarPrefix = { bluePlayerHeliGroupNames } -- #GROUP name prefixes used for useprefix=true
csarBlue.countryblue = country.id.USA
csarBlue.countryred = country.id.RUSSIA
csarBlue.limitmaxdownedpilots = false
csarBlue.topmenuname = "CSAR"

-- generate some bad guys around the downed pilot
function csarBlue:OnAfterPilotDown(from, event, to, downedPilotGroup, frequency, groupname, coordinates_text)
    local howManyBadGuys = math.random(4, 8)
    local downedPilotCoordinate = downedPilotGroup:GetCoordinate()
    if downedPilotCoordinate:IsSurfaceTypeWater() or downedPilotCoordinate:IsSurfaceTypeShallowWater() then
        env.info("CSAR is over water, no bad guys to generate")
        return
    end
    for i = 1, howManyBadGuys do
        Mission.CSARcounter = Mission.CSARcounter + 1
        -- Return a random Vec2 within an Outer Radius and optionally NOT within an Inner Radius of the COORDINATE
        local randomCoordinateAsVec2 = downedPilotCoordinate:GetRandomVec2InRadius(1000, 500)
        local randomCoordinate = COORDINATE:NewFromVec2(randomCoordinateAsVec2)
        local redInfantryTemplateToSpawn = ""
        local isRegularOrMilitia = math.random(0, 100)
        if isRegularOrMilitia > 50 then
            redInfantryTemplateToSpawn = "RED INFANTRY REGULAR"
        else
            redInfantryTemplateToSpawn = "RED INFANTRY MILITIA"
        end
        local badGuyName = "RED INFANTRY" .. "#" .. Mission.CSARcounter
        local badGuy = SPAWN:NewWithAlias(redInfantryTemplateToSpawn, badGuyName)
                            :InitPositionCoordinate(randomCoordinate)
                            :Spawn()
        Mission.CSARbadGuys[badGuyName] = downedPilotGroup:GetName()
    end
end

-- cleanup ground bad guys after pilot is safe on board
function csarBlue:OnAfterBoarded(from, event, to, heliName, downedPilotGroupName, downedPilotNameGroupDescription)
    for redInfantryBadGuyName, downedPilotGroupNameInTable in pairs(Mission.CSARbadGuys) do
        if downedPilotGroupNameInTable == downedPilotGroupName then
            local redBadGuyGroupToDestroy = GROUP:FindByName(redInfantryBadGuyName)
            if redBadGuyGroupToDestroy ~= nil then
                redBadGuyGroupToDestroy:Destroy(false)
            end
            Mission.CSARbadGuys[redInfantryBadGuyName] = nil
        end
    end
end

csarBlue:__Start(5)

env.info("CSAR loaded...")
trigger.action.outText("CSAR loaded ...", 10)

-- ADD RADIO MENUS ***
function Mission.addBlueRadioMenus()
    local bluePlayerGroups = SET_GROUP:New():FilterPrefixes("BLUE PLAYER"):FilterActive(true):FilterStart()
    bluePlayerGroups:ForEach(
            function(playerGroup)
                local groupId = playerGroup:GetID()
                if Mission.radioMenusAdded[tostring(groupId)] == nil then
                    Mission.radioMenusAdded[tostring(groupId)] = true

                    local afacMenuRoot = missionCommands.addSubMenuForGroup(groupId, "AFAC")
                    missionCommands.addCommandForGroup(groupId, "Request new AFAC", afacMenuRoot, Mission.spawnBlueAfac, groupId)
                    missionCommands.addCommandForGroup(groupId, "Report contacts", afacMenuRoot, Mission.afacGetReport, groupId, coalition.side.BLUE)
                    afacMenuSmoke = missionCommands.addSubMenuForGroup(groupId, "Smoke target in", afacMenuRoot)
                    missionCommands.addCommandForGroup(groupId, "ALFA", afacMenuSmoke, Mission.afacSmokeTarget, groupId, AlfaZone:GetName())
                    missionCommands.addCommandForGroup(groupId, "BETA", afacMenuSmoke, Mission.afacSmokeTarget, groupId, BetaZone:GetName())
                    missionCommands.addCommandForGroup(groupId, "GAMMA", afacMenuSmoke, Mission.afacSmokeTarget, groupId, GammaZone:GetName())
                    missionCommands.addCommandForGroup(groupId, "Truck Parking", afacMenuSmoke, Mission.afacSmokeTruckParking, groupId)
                    missionCommands.addCommandForGroup(groupId, "Friendly Units Flare", afacMenuSmoke, Mission.blueUnitsFlare, groupId)

                    local missionStatusMenu = missionCommands.addSubMenuForGroup(groupId, "Mission")
                    missionCommands.addCommandForGroup(groupId, "Bridge Status", missionStatusMenu, Mission.getBridgeStatus, groupId)
                    missionCommands.addCommandForGroup(groupId, "Capture Zone Status", missionStatusMenu, Mission.getCaptureZoneStatus, groupId)
                    missionCommands.addCommandForGroup(groupId, "List Radio frequencies", missionStatusMenu, Mission.listRadioFrequencies, groupId)
                end
            end
    )
    local redPlayerGroups = SET_GROUP:New():FilterPrefixes("RED PLAYER"):FilterActive(true):FilterStart()
    redPlayerGroups:ForEach(
            function(playerGroup)
                local groupId = playerGroup:GetID()
                if Mission.radioMenusAdded[tostring(groupId)] == nil then
                    Mission.radioMenusAdded[tostring(groupId)] = true
                    missionCommands.addCommandForGroup(groupId, "Report ground contacts", nil, Mission.afacGetReport, groupId, coalition.side.RED)
                    missionCommands.addCommandForGroup(groupId, "Bridge Status", nil, Mission.getBridgeStatus, groupId)
                    missionCommands.addCommandForGroup(groupId, "Capture Zone Status", nil, Mission.getCaptureZoneStatus, groupId)
                    missionCommands.addCommandForGroup(groupId, "Friendly Units Flare", nil, Mission.redUnitsFlare, groupId)
                end
            end
    )
end

-- reschedule for users that change slot or coalition
RADIO_MENU_SCHEDULER = SCHEDULER:New(nil,
        function()
            -- ADD MENUS FOR BLUE
            Mission.addBlueRadioMenus()
        end, {}, 0, 30, 0)

-- LIST RADIO FREQUENCIES FUNCTIONS ***

function Mission.listRadioFrequencies(_groupId)
    trigger.action.outTextForGroup(_groupId,
            [[
            Radio  presets:
            #1/101 250 MHz (Air units)
            #2/102 260 MHz (Batumi ATC)
            #3/103 CVN-71 271 MHz / TCN 71X / ICLS 11
            #4/104 Tanker Shell 269 MHz / TCN 69Y

            Batumi TCN 16X
            Kobuleti TCN 67X
            Senaki TCN 31X
            Madrif FARP 131 MHz

            Callsigns
            Enfield: USN CAP
            Springfield: USAF CAP
            Dodge: USAF CAS/BAI
            Ford: USAAC UH-1
            Chevy: USN CAS
            Pontiac: AFAC
            ]]
    , 15, false)
    trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

env.info("Radio Frequencies loaded...")
trigger.action.outText("Radio Frequencies loaded ...", 10)

-- END ***

env.info("Mission loaded OK ...")
trigger.action.outText("Mission loaded OK ...", 10)